#ifndef _HPROSE_TAGS_HPP_
#define _HPROSE_TAGS_HPP_

enum class Tags : unsigned char {
    TagError  = 0,
	// Serialize Type
	Integer   = 'i',
	Long      = 'l',
	Double    = 'd',
	Null      = 'n',
	Empty     = 'e',
	True      = 't',
	False     = 'f',
	NaN       = 'N',
	Infinity  = 'I',
	Date      = 'D',
	Time      = 'T',
	UTC       = 'Z',
	Bytes     = 'b',
	UTF8Char  = 'u',
	String    = 's',
	GUID      = 'g',
	List      = 'a',
	Map       = 'm',
	Class     = 'c',
	Object    = 'o',
	Ref       = 'r',
	// Serialize Marks
	Pos         = '+',
	Neg         = '-',
	Semicolon   = ';',
	Openbrace   = '{',
	Closebrace  = '}',
	Quote       = '"',
	Point       = '.',
	// Protocol s
	Functions  = 'F',
	Call       = 'C',
	Result     = 'R',
	Argument   = 'A',
	Error      = 'E',
	End        = 'z',
    // Numbers
    Num0       = '0',
    Num1       = '1',
    Num2       = '2',
    Num3       = '3',
    Num4       = '4',
    Num5       = '5',
    Num6       = '6',
    Num7       = '7',
    Num8       = '8',
    Num9       = '9',
};

#endif
